apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: node-s2i-build-dslim
  namespace: {{ buildns }}
spec:
  params:
  - default: {{ tekton_docker_dslim_image }}
    description: The location of the kaniko builder image.
    name: builderimage
    type: string
  - default: {{ tekton_docker_builder_image }}
    description: The location of the Docker builder image.
    name: pushimage
    type: string
  - default: {{ tekton_docker_dind_image }}
    description: The location of the Docker in Docker image.
    name: dindimage
    type: string
  - name: dstimage
    description: Where to push the resulting image
    type: string
  - default: ""
    description: Forces USER in Dockerfile - either a specific uid, or any string would translate to {{ k8s_unprivileged_userid }}.
    name: forceuid
    type: string
  - default: .
    description: The location of the path to run s2i from
    name: contextdir
    type: string
  - default: {{ npmjs_registry }}
    description: NPMJS Repository Endpoint
    name: npmmirror
    type: string
  - default: nodejs:master
    description: S2i Base Image
    name: fromimage
    type: string
  - default: "{{ docker_registry }}"
    description: When pulling/pushing from insecure registries, set its address here
    name: insecure
    type: string
  results:
  - description: Digest of the image just built.
    name: IMAGE_DIGEST
  steps:
  - args:
    - -c
    - |
        if test -s $(params.contextdir)/Dockerfile.debug-s2i; then
            cat $(params.contextdir)/Dockerfile.debug-s2i
        else
            echo FROM opsperator/nodejs
            echo USER root
            echo COPY . /tmp/src/
            echo RUN chown -R {{ k8s_unprivileged_userid }}:0 /tmp/src
            echo "RUN set -x && env && ls -al /tmp/src"
            echo USER {{ k8s_unprivileged_userid }}
            echo "RUN set -x && env && DEBUG=yay /usr/libexec/s2i/assemble"
            echo 'CMD $STI_SCRIPTS_PATH/run'
        fi >$(params.contextdir)/Dockerfile
        if test "$(params.fromimage)"; then \
            REPLACE=`awk '/FROM /{print $2}' "$(params.contextdir)/Dockerfile" | tail -1`; \
{% if k8s_flavor == 'kubernetes' %}
            if echo "$(params.fromimage)" | grep -E '((docker|gcr|quay).io|/.*/)' >/dev/null; then \
                WITH="$(params.fromimage)"; \
            else \
                WITH="{{ docker_registry }}/{{ buildns }}/$(params.fromimage)"; \
            fi; \
{% else %}
            WITH="$(params.fromimage)"; \
{% endif %}
            sed -i "s|^[ ]*FROM[ ]*$REPLACE|FROM $WITH|" "$(params.contextdir)/Dockerfile"; \
        fi; \
        if test "$(params.forceuid)" -a "$(params.forceuid)" -gt 0 >/dev/null 2>&1; then \
            if ! grep -E '^USER[ \t]*[0-9]' "$(params.contextdir)/Dockerfile" >/dev/null; then \
                echo USER $(params.forceuid) >>"$(params.contextdir)/Dockerfile"; \
            fi; \
        elif test "$(params.forceuid)"; then \
            if ! grep -E '^USER[ \t]*[0-9]' "$(params.contextdir)/Dockerfile" >/dev/null; then \
                echo USER {{ k8s_unprivileged_userid }} >>"$(params.contextdir)/Dockerfile"; \
            fi; \
        fi
    command:
    - /bin/sh
    image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
    name: generate-environ
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_scripts_cpu_limit }}"
        memory: {{ tekton_scripts_memory_limit }}
      requests:
        cpu: "{{ tekton_scripts_cpu_request }}"
        memory: {{ tekton_scripts_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
      privileged: true
{% endif %}
    workingDir: "$(workspaces.source.path)"
  - args:
    - --state-path
    - /dslim-state
    - --in-container
    - build
    - --cbo-build-arg "DO_UPGRADE=true"
    - --http-probe=false
    - --dockerfile
    - Dockerfile
    - --dockerfile-context
    - $(workspaces.source.path)
    - $(params.dstimage)
    env:
    - name: DOCKER_HOST
      value: tcp://127.0.0.1:2376
    - name: DOCKER_TLS_VERIFY
      value: '1'
    - name: DOCKER_CERT_PATH
      value: /certs/client
{% if proxy_host | default(False) %}
    - name: http_proxy
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: https_proxy
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: no_proxy
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
    - name: HTTP_PROXY
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: HTTPS_PROXY
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: NO_PROXY
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
    - name: http_proxy
      value: {{ squid_address }}
    - name: https_proxy
      value: {{ squid_address }}
    - name: no_proxy
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
    - name: HTTP_PROXY
      value: {{ squid_address }}
    - name: HTTPS_PROXY
      value: {{ squid_address }}
    - name: NO_PROXY
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
    - name: http_proxy
      value: ""
    - name: https_proxy
      value: ""
    - name: no_proxy
      value: ""
    - name: HTTP_PROXY
      value: ""
    - name: HTTPS_PROXY
      value: ""
    - name: NO_PROXY
      value: ""
{% endif %}
    - name: NO_AUDIT
      value: yep
    - name: NODE_ENV
      value: production
    - name: NPM_MIRROR
      value: $(params.npmmirror)
    image: $(params.builderimage)
    name: build
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_docker_build_cpu_limit }}"
        memory: {{ tekton_docker_build_memory_limit }}
      requests:
        cpu: "{{ tekton_docker_build_cpu_request }}"
        memory: {{ tekton_docker_build_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
{% if 0 == 1 %}
      runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      privileged: true
{% endif %}
{% endif %}
    volumeMounts:
    - mountPath: /dslim-state
      name: state
    - mountPath: /certs/client
      name: dind-certs
    workingDir: "$(workspaces.source.path)"
  - command:
    - /bin/sh
    - -c
    - |
        SLIM_IMAGE=$(docker images | awk '/docker-slim.*[0-9]*\.slim/{print $1;exit 0;}')
        docker tag "$SLIM_IMAGE" $(params.dstimage)
        docker push $(params.dstimage)
        IMGMATCH=`echo $(params.dstimage) | cut -d: -f1`
        IMGREF=`docker images | grep $IMGMATCH | awk '{print $3}' | head -1`
        docker inspect $IMGREF | awk -F '"' '/Id/{print $4}' >$(workspaces.source.path)/image-digest
    name: push
    image: $(params.pushimage)
    env:
    - name: DOCKER_HOST
      value: tcp://127.0.0.1:2376
    - name: DOCKER_TLS_VERIFY
      value: '1'
    - name: DOCKER_CERT_PATH
      value: /certs/client
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_docker_push_cpu_limit }}"
        memory: {{ tekton_docker_push_memory_limit }}
      requests:
        cpu: "{{ tekton_docker_push_cpu_request }}"
        memory: {{ tekton_docker_push_memory_request }}
{% else %}
    resources: {}
{% endif %}
    volumeMounts:
    - mountPath: /certs/client
      name: dind-certs
  - args:
    - -c
    - |
{% if do_debugs %}
        set -x;
        ls $(workspaces.source.path)
        cat $(workspaces.source.path)/image-digest || echo no digest
{% endif %}
        cat $(workspaces.source.path)/image-digest | tee $(results.IMAGE_DIGEST.path)
    command:
    - /bin/sh
    image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
    name: digest-to-results
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_scripts_cpu_limit }}"
        memory: {{ tekton_scripts_memory_limit }}
      requests:
        cpu: "{{ tekton_scripts_cpu_request }}"
        memory: {{ tekton_scripts_memory_request }}
{% else %}
    resources: {}
{% endif %}
  sidecars:
  - args:
    - --storage-driver=vfs
    - --userland-proxy=false
{% if do_debugs %}
    - --debug
{% endif %}
    - --insecure-registry=$(params.insecure)
    env:
    - name: DOCKER_TLS_CERTDIR
      value: /certs
    image: $(params.dindimage)
    name: dind
    readinessProbe:
      periodSeconds: 1
      exec:
        command:
        - ls
        - /certs/client/ca.pem
{% if tekton_uses_resources_limits | default(True) %}
    resources:
      limits:
        cpu: "{{ tekton_docker_dind_cpu_limit }}"
        memory: {{ tekton_docker_dind_memory_limit }}
      requests:
        cpu: "{{ tekton_docker_dind_cpu_request }}"
        memory: {{ tekton_docker_dind_memory_request }}
{% else %}
    resources: {}
{% endif %}
    securityContext:
      privileged: true
    volumeMounts:
    - mountPath: /certs/client
      name: dind-certs
  volumes:
  - emptyDir: {}
    name: dind-certs
  - emptyDir: {}
    name: state
  workspaces:
  - name: source
